<html>
<head>
<title>OgreKeyFrame.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreKeyFrame.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreKeyFrame_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __KeyFrame_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __KeyFrame_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAny_8h.html">OgreAny.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre 
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 
<a name="l00055"></a><a class="code" href="classOgre_1_1KeyFrame.html">00055</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAlloc</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* parent, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="classOgre_1_1KeyFrame.html#a2f8e964ccf18553eef80f93c26d0e7bc">00062</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1KeyFrame.html#a2f8e964ccf18553eef80f93c26d0e7bc">~KeyFrame</a>() {}
<a name="l00063"></a>00063 
<a name="l00065"></a><a class="code" href="classOgre_1_1KeyFrame.html#abc6cab6ca252dffa5f7955fbf25707f8">00065</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1KeyFrame.html#abc6cab6ca252dffa5f7955fbf25707f8" title="Gets the time of this keyframe in the animation sequence.">getTime</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTime; }
<a name="l00066"></a>00066 
<a name="l00068"></a>00068         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* _clone(<a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* newParent) <span class="keyword">const</span>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="keyword">protected</span>:
<a name="l00072"></a><a class="code" href="classOgre_1_1KeyFrame.html#a34af076d7fda5e0da5fd4be8368a28a5">00072</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1KeyFrame.html#a34af076d7fda5e0da5fd4be8368a28a5">mTime</a>;
<a name="l00073"></a><a class="code" href="classOgre_1_1KeyFrame.html#ae9b9c257bf51af1be9bec3e8f50b4a41">00073</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* <a class="code" href="classOgre_1_1KeyFrame.html#ae9b9c257bf51af1be9bec3e8f50b4a41">mParentTrack</a>;
<a name="l00074"></a>00074     };
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00079"></a><a class="code" href="classOgre_1_1NumericKeyFrame.html">00079</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1NumericKeyFrame.html" title="Specialised KeyFrame which stores any numeric value.">NumericKeyFrame</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081     <span class="keyword">public</span>:
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1NumericKeyFrame.html" title="Specialised KeyFrame which stores any numeric value.">NumericKeyFrame</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* parent, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00084"></a><a class="code" href="classOgre_1_1NumericKeyFrame.html#a9e05848ca0aca03fb7a6e300c7d4b9f8">00084</a>         <a class="code" href="classOgre_1_1NumericKeyFrame.html#a9e05848ca0aca03fb7a6e300c7d4b9f8">~NumericKeyFrame</a>() {}
<a name="l00085"></a>00085 
<a name="l00087"></a>00087         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only types which support ...">AnyNumeric</a>&amp; getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00092"></a>00092         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only types which support ...">AnyNumeric</a>&amp; val);
<a name="l00093"></a>00093 
<a name="l00095"></a>00095         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* _clone(<a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* newParent) <span class="keyword">const</span>;
<a name="l00096"></a>00096     <span class="keyword">protected</span>:
<a name="l00097"></a><a class="code" href="classOgre_1_1NumericKeyFrame.html#a49314a3f085a20499438b3c56e01f79e">00097</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only types which support ...">AnyNumeric</a> <a class="code" href="classOgre_1_1NumericKeyFrame.html#a49314a3f085a20499438b3c56e01f79e">mValue</a>;
<a name="l00098"></a>00098     };
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00102"></a><a class="code" href="classOgre_1_1TransformKeyFrame.html">00102</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>
<a name="l00103"></a>00103     {
<a name="l00104"></a>00104     <span class="keyword">public</span>:
<a name="l00106"></a>00106         <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* parent, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00107"></a><a class="code" href="classOgre_1_1TransformKeyFrame.html#ab3f1fdf74fd7841e65efea2a011100d9">00107</a>         <a class="code" href="classOgre_1_1TransformKeyFrame.html#ab3f1fdf74fd7841e65efea2a011100d9">~TransformKeyFrame</a>() {}
<a name="l00114"></a>00114         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTranslate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; trans);
<a name="l00115"></a>00115 
<a name="l00117"></a>00117         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getTranslate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00124"></a>00124         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setScale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; scale);
<a name="l00125"></a>00125 
<a name="l00127"></a>00127         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00133"></a>00133         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRotation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rot);
<a name="l00134"></a>00134 
<a name="l00136"></a>00136         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getRotation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00137"></a>00137 
<a name="l00139"></a>00139         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* _clone(<a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* newParent) <span class="keyword">const</span>;
<a name="l00140"></a>00140     <span class="keyword">protected</span>:
<a name="l00141"></a><a class="code" href="classOgre_1_1TransformKeyFrame.html#aa64713cf3569300e7c394a7aca5e9fd6">00141</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1TransformKeyFrame.html#aa64713cf3569300e7c394a7aca5e9fd6">mTranslate</a>;
<a name="l00142"></a><a class="code" href="classOgre_1_1TransformKeyFrame.html#ae71c63b50724dc7b5b866158eb9062f4">00142</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1TransformKeyFrame.html#ae71c63b50724dc7b5b866158eb9062f4">mScale</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1TransformKeyFrame.html#afc8fa0ac28a8af32d48e55a02daae0c1">00143</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1TransformKeyFrame.html#afc8fa0ac28a8af32d48e55a02daae0c1">mRotate</a>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     };
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00153"></a><a class="code" href="classOgre_1_1VertexMorphKeyFrame.html">00153</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexMorphKeyFrame.html" title="Specialised KeyFrame which stores absolute vertex positions for a complete buffer, designed to be interpolated with other keys in the same track.">VertexMorphKeyFrame</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>
<a name="l00154"></a>00154     {
<a name="l00155"></a>00155     <span class="keyword">public</span>:
<a name="l00157"></a>00157         <a class="code" href="classOgre_1_1VertexMorphKeyFrame.html" title="Specialised KeyFrame which stores absolute vertex positions for a complete buffer, designed to be interpolated with other keys in the same track.">VertexMorphKeyFrame</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* parent, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00158"></a><a class="code" href="classOgre_1_1VertexMorphKeyFrame.html#a48d3755bc604497aa3beef2328e0cea3">00158</a>         <a class="code" href="classOgre_1_1VertexMorphKeyFrame.html#a48d3755bc604497aa3beef2328e0cea3">~VertexMorphKeyFrame</a>() {}
<a name="l00166"></a>00166         <span class="keywordtype">void</span> setVertexBuffer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; buf);
<a name="l00167"></a>00167 
<a name="l00169"></a>00169         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; getVertexBuffer(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00170"></a>00170 
<a name="l00172"></a>00172         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* _clone(<a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* newParent) <span class="keyword">const</span>;      
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <span class="keyword">protected</span>:
<a name="l00175"></a><a class="code" href="classOgre_1_1VertexMorphKeyFrame.html#aadbd8587ded444474ce4054377289de3">00175</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1VertexMorphKeyFrame.html#aadbd8587ded444474ce4054377289de3">mBuffer</a>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     };
<a name="l00178"></a>00178 
<a name="l00183"></a><a class="code" href="classOgre_1_1VertexPoseKeyFrame.html">00183</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html" title="Specialised KeyFrame which references a Mesh::Pose at a certain influence level, which stores offsets...">VertexPoseKeyFrame</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>
<a name="l00184"></a>00184     {
<a name="l00185"></a>00185     <span class="keyword">public</span>:
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html" title="Specialised KeyFrame which references a Mesh::Pose at a certain influence level, which stores offsets...">VertexPoseKeyFrame</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* parent, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00188"></a><a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a431d110129e738fa4ff118568252f839">00188</a>         <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a431d110129e738fa4ff118568252f839">~VertexPoseKeyFrame</a>() {}
<a name="l00189"></a>00189 
<a name="l00194"></a><a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html">00194</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html" title="Reference to a pose at a given influence level.">PoseRef</a>
<a name="l00195"></a>00195         {
<a name="l00203"></a><a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html#a172a06f5c2697f3e20bc2cf8556708ab">00203</a>             <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html#a172a06f5c2697f3e20bc2cf8556708ab" title="The linked pose index.">poseIndex</a>;
<a name="l00207"></a><a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html#ab4c9428aafb3b9e171a0eed21fb7d9ed">00207</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html#ab4c9428aafb3b9e171a0eed21fb7d9ed" title="Influence level of the linked pose.">influence</a>;
<a name="l00208"></a>00208 
<a name="l00209"></a><a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html#aa850e724aeef6ca08ac781ecef0c6b6d">00209</a>             <a class="code" href="structOgre_1_1VertexPoseKeyFrame_1_1PoseRef.html#aa850e724aeef6ca08ac781ecef0c6b6d">PoseRef</a>(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> p, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> i) : poseIndex(p), influence(i) {}
<a name="l00210"></a>00210         };
<a name="l00211"></a><a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a20c7ef2f81407f7945ac3d9e2bd844a9">00211</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;PoseRef&gt;::type</a> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a20c7ef2f81407f7945ac3d9e2bd844a9">PoseRefList</a>;
<a name="l00212"></a>00212 
<a name="l00216"></a>00216         <span class="keywordtype">void</span> addPoseReference(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> poseIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> influence);
<a name="l00220"></a>00220         <span class="keywordtype">void</span> updatePoseReference(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> poseIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> influence);
<a name="l00224"></a>00224         <span class="keywordtype">void</span> removePoseReference(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> poseIndex);
<a name="l00226"></a>00226         <span class="keywordtype">void</span> removeAllPoseReferences(<span class="keywordtype">void</span>);
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00230"></a>00230         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a20c7ef2f81407f7945ac3d9e2bd844a9">PoseRefList</a>&amp; getPoseReferences(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00231"></a>00231 
<a name="l00232"></a><a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a1edac52d5414ad95786cc9180bb6d080">00232</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;PoseRefList&gt;</a> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a1edac52d5414ad95786cc9180bb6d080">PoseRefIterator</a>;
<a name="l00233"></a><a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a5ca079fc1fc8647a32d5c45c305e7720">00233</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;PoseRefList&gt;</a> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a5ca079fc1fc8647a32d5c45c305e7720">ConstPoseRefIterator</a>;
<a name="l00234"></a>00234 
<a name="l00236"></a>00236         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">PoseRefIterator</a> getPoseReferenceIterator(<span class="keywordtype">void</span>);
<a name="l00237"></a>00237 
<a name="l00239"></a>00239         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstPoseRefIterator</a> getPoseReferenceIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00240"></a>00240 
<a name="l00242"></a>00242         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* _clone(<a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* newParent) <span class="keyword">const</span>;
<a name="l00243"></a>00243         
<a name="l00244"></a>00244         <span class="keywordtype">void</span> _applyBaseKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html" title="Specialised KeyFrame which references a Mesh::Pose at a certain influence level, which stores offsets...">VertexPoseKeyFrame</a>* base);
<a name="l00245"></a>00245         
<a name="l00246"></a>00246     <span class="keyword">protected</span>:
<a name="l00247"></a><a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#ad17b809f17245333dc58f7d7a92ca521">00247</a>         <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#a20c7ef2f81407f7945ac3d9e2bd844a9">PoseRefList</a> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html#ad17b809f17245333dc58f7d7a92ca521">mPoseRefs</a>;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249     };
<a name="l00253"></a>00253 }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="preprocessor">#endif</span>
<a name="l00257"></a>00257 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
